---
title: CSSRuleList
slug: Web/API/CSSRuleList
tags:
  - API
  - CSSOM
  - Interface
  - Reference
---
<p>{{ APIRef("CSSOM") }}</p>

<p>A <code>CSSRuleList</code> is an (indirect-modify only) array-like object containing an ordered collection of <code><a href="/en/DOM/cssRule" title="en/DOM/cssRule">CSSRule</a></code> objects.</p>

<h2 id="Syntax">Description</h2>

<p>Each <code>CSSRule</code> can be accessed as <code><var>rules</var>.item(<var>index</var>),</code> or <code><var>rules</var>[<var>index</var>]</code>, where <code><var>rules</var></code> is an object implementing the <code>CSSRuleList</code> interface (such as <code>{{domxref("CSSStylesheet","","",1)}}.cssRules</code>), and <code><var>index</var></code> is the 0-based index of the rule, in the order as it appears in the style sheet CSS. The number of rules in the list is <code><var>rules</var>.length</code>.</p>

<p>Note that being <em>indirect-modify</em> (<a href="https://www.w3.org/TR/cssom/#cssstylesheet">changeable</a> but <a href="https://www.w3.org/TR/cssom/#cssrulelist">only having</a> read-methods), rules are <strong>NOT</strong> added or removed from the list directly, but instead here, only via its parent stylesheet. In fact, {{domxref("CSSStyleSheet.insertRule",".insertRule()")}} and {{domxref("CSSStyleSheet.deleteRule",".deleteRule()")}} are not even methods of CSSRuleList, but only of {{domxref("CSSStyleSheet")}}. If however, for some reason the list does need to be modified but has no parent stylesheet (perhaps being a <em><a href="https://www.w3.org/TR/cssom/#cssstylesheet">livecopy</a></em> of a list that does), it cannot just be assigned one (as it has <a href="https://www.w3.org/TR/cssom/#cssrulelist">no such property</a>), and neither can it be assigned to one (as stylesheet.css<code>Rules </code>is <a href="https://www.w3.org/TR/cssom/#cssstylesheet">read-only</a>), but it must unfortunately be <strong>inserted</strong> into one, rule by rule, and unless combining lists, after any existing list therein is deleted, rule by rule.</p>

<h2 id="Example">Example</h2>

<pre class="brush: js">// get the first style sheet’s first rule
var first_rule = document.styleSheets[0].cssRules[0];
</pre>

<h2 id="Notes">See also</h2>

<ul>
 <li><code><a href="/en/DOM/cssRule" title="en/DOM/CSSRule">CSSRule</a></code></li>
</ul>

<h3 id="CSSRuleList_implementations">CSSRuleList implementations</h3>

<p>There are multiple properties in the CSSOM that will return a <code>CSSRuleList</code>. They are:</p>

<ul>
 <li>{{ domxref("CSSStyleSheet") }} property {{ domxref("CSSStyleSheet/cssRules", "cssRules") }}</li>
 <li>{{ domxref("CSSMediaRule") }} property {{ domxref("CSSMediaRule/cssRules", "cssRules") }}</li>
 <li>{{ domxref("CSSKeyframesRule") }} property {{ domxref("CSSKeyframesRule/cssRules", "cssRules") }}</li>
 <li>{{ domxref("CSSMozDocumentRule") }} property {{ domxref("CSSMozDocumentRule/cssRules", "cssRules") }}</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSSOM', '#the-cssrulelist-interface', 'CSSRuleList')}}</td>
   <td>{{Spec2('CSSOM')}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CSSRuleList")}}</p>
